searchNodes=[{"doc":"A simple state machine representing the state of a two-phase commit, as well as providing next steps to be taken in the case of a coordinator recovery after a crash.","ref":"TwoPhaseCommit.html","title":"TwoPhaseCommit","type":"module"},{"doc":"Records a participant's &quot;abort&quot; vote and moves the transaction to the rolling_back state.","ref":"TwoPhaseCommit.html#aborted/2","title":"TwoPhaseCommit.aborted/2","type":"function"},{"doc":"Adds a participant to the transaction while it's in the interactive phase.","ref":"TwoPhaseCommit.html#add_participant/2","title":"TwoPhaseCommit.add_participant/2","type":"function"},{"doc":"Notes that a participant has committed, moves to the committed state when all have committed.","ref":"TwoPhaseCommit.html#committed/2","title":"TwoPhaseCommit.committed/2","type":"function"},{"doc":"Creates a new TwoPhaseCommit state structs with the given participants.The following keyword parameters can be provided::id - stores the transaction id (globally unique) :client - stores an arbitrary identifying the requesting entity (a pid, etc)","ref":"TwoPhaseCommit.html#new/2","title":"TwoPhaseCommit.new/2","type":"function"},{"doc":"Indicates what actions need to be performed next in order to move the transaction forward.This is useful for the coordinator to determine where the transaction left off after recovering from a crash.","ref":"TwoPhaseCommit.html#next_action/1","title":"TwoPhaseCommit.next_action/1","type":"function"},{"doc":"Returns a list of all participants.","ref":"TwoPhaseCommit.html#participants/1","title":"TwoPhaseCommit.participants/1","type":"function"},{"doc":"Moves the transaction to the voting phase.","ref":"TwoPhaseCommit.html#prepare/1","title":"TwoPhaseCommit.prepare/1","type":"function"},{"doc":"Records a participant's &quot;prepared&quot; vote, moves to the committing phase when all are prepared.","ref":"TwoPhaseCommit.html#prepared/2","title":"TwoPhaseCommit.prepared/2","type":"function"},{"doc":"Notes that a participant has rolled back, moves to the aborted state when all have rolled back.","ref":"TwoPhaseCommit.html#rolled_back/2","title":"TwoPhaseCommit.rolled_back/2","type":"function"},{"doc":"","ref":"TwoPhaseCommit.html#t:client/0","title":"TwoPhaseCommit.client/0","type":"type"},{"doc":"","ref":"TwoPhaseCommit.html#t:id/0","title":"TwoPhaseCommit.id/0","type":"type"},{"doc":"","ref":"TwoPhaseCommit.html#t:next_action/0","title":"TwoPhaseCommit.next_action/0","type":"type"},{"doc":"","ref":"TwoPhaseCommit.html#t:opt/0","title":"TwoPhaseCommit.opt/0","type":"type"},{"doc":"","ref":"TwoPhaseCommit.html#t:opts/0","title":"TwoPhaseCommit.opts/0","type":"type"},{"doc":"","ref":"TwoPhaseCommit.html#t:participant/0","title":"TwoPhaseCommit.participant/0","type":"type"},{"doc":"","ref":"TwoPhaseCommit.html#t:participants/0","title":"TwoPhaseCommit.participants/0","type":"type"},{"doc":"","ref":"TwoPhaseCommit.html#t:state/0","title":"TwoPhaseCommit.state/0","type":"type"},{"doc":"","ref":"TwoPhaseCommit.html#t:t/0","title":"TwoPhaseCommit.t/0","type":"type"},{"doc":"TwoPhaseCommitWORK IN PROGRESSTwo Phase Commit state machine model.You can use the state machine to build a transaction coordinator, there's a bare-bones GenServer implementation included.","ref":"readme.html","title":"TwoPhaseCommit","type":"extras"},{"doc":"The package can be installed by adding two_phase_commit to your list of dependencies in mix.exs:def deps do [ {:two_phase_commit, &quot;~&gt; 0.1.0&quot;} ] endThe docs can be found at https://hexdocs.pm/two_phase_commit.","ref":"readme.html#installation","title":"TwoPhaseCommit - Installation","type":"extras"},{"doc":"+ | | new/2 | v +-------+------+ +--+ | add_participant/2 | | :interactive | +-&gt;+ | aborted/2 +-------+------+ | +------+ | prepare/1 | | v | v +-------+------+ +----+------+---+ +---------------+ +--+ | aborted/2 | | rolled_back/2 | | prepared/2 | | :voting +----------&gt;+ :rolling_back +--------------&gt;+ :aborted | +-&gt;+ | | | | | +-------+------+ +----+------+---+ +---------------+ | | ^ | prepared/2 | | v +------+ +-------+-------+ +--+ | rolled_back/2 committed/2 | | :committing | +-&gt;+ | +-------+-------+ | | committed/2 v +-------+-------+ | | | :committed | | | +---------------+","ref":"readme.html#state-machine-diagram","title":"TwoPhaseCommit - State Machine Diagram","type":"extras"}]